<div class="container-fluid">
  <div class="card">
    <div class="card-header bg-info">
      <div class="row">
        <div class="col-sm-6">
          Account Heads
          <input type="text"
                 pInputText placeholder="Search Account Heads"
                 [(ngModel)]="searchedName">
          <button type="button"
                  label="Search"
                  class="btn btn-success btn-xs"
                  (click)="searchAccountHead(searchedName)">
            Search
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-xs fa-pull-right"
                  (click)="addEditBudgetHead('Add', null)">
            New Account Head
          </button>
        </div>
      </div>

    </div>
    <div class="card-body">
      <p-table id="exportTable"
               class="text-left"
               [columns]="columnName"
               [value]="(data$)"
               [resizableColumns]="true"
               [autoLayout]="true"
               [paginator]="true"
               [rows]="10"
               [showCurrentPageReport]="true">
        <ng-template pTemplate="caption">
          List of Account Heads
          :&nbsp;{{ totalRecords }}
        </ng-template>
        <ng-template pTemplate="header" let-columns>
          <tr>
            <th *ngFor="let col of columns" [pSortableColumn]="col.value">
              {{col.name}}
              <p-sortIcon [field]="col.value"></p-sortIcon>
            </th>
          </tr>
        </ng-template>

        <ng-template pTemplate="body" let-list let-i="rowIndex">
          <tr [ngStyle]="{'background-color':i%2 === 0 ? '#fafafa' : '#e9ecef'}">
            <td>{{ i + 1}}</td>
            <td>{{ list.description }}</td>
            <td>{{ list.code}}</td>
            <td>{{ list.accountNumber}}</td>
            <td>{{ list.budgetHead }}</td>
            <td>
              <p-inputSwitch
                [name]="list.status"
                [inputId]="list.status"
                (onChange)="handleChange($event, list.accountHeadId)"
                [ngModel]="list.status === 'ACTIVE'? true: false ">
              </p-inputSwitch>
            </td>
            <td>
              {{ list.staffAccount }}
            </td>
            <td>
              <a (click)="addEditBudgetHead('Edit', list)">
                <svg class="bi bi-pencil-square"
                     width="1em"
                     height="1em"
                     viewBox="0 0 16 16"
                     fill="currentColor"
                     xmlns="http://www.w3.org/2000/svg">
                  <path
                    d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456l-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                  <path fill-rule="evenodd"
                        d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                </svg>
              </a>

            </td>
          </tr>
        </ng-template>
      </p-table>
    </div>
  </div>
</div>


<p-dialog [(visible)]="display"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '490px', height: 'auto'}">
  <p-header>
    {{addEditType}} Account Head
  </p-header>
  <form [formGroup]="addEditAccountHeadForm">
    <div class="form-group">
      <p-checkbox formControlName="staffAccount"
                  [binary]="true"
                  label="Is Staff Account"
                  name="staffAccount"
                  (ngModelChange)="fetchBudgetHeads($event)"
                  id="staffAccount"></p-checkbox>
    </div>
    <div class="form-group" *ngIf="this.addEditAccountHeadForm.value.staffAccount === false">
      <label for="budgetHeadId">Budget Head</label>
      <select id="budgetHeadId"
              class="form-control"
              formControlName="budgetHeadId"
              name="expType">
        <option *ngFor="let event of (budgetHeads); let i = index"
                [ngValue]="(budgetHeads)[i].budgetHeadId"
        >{{(budgetHeads)[i].budgetHead + '( ' + (budgetHeads)[i].code + ')' }}</option>
      </select>
    </div>

    <div class="form-group">
      <label for="description">Description<span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="description"
             formControlName="description"
             [ngClass]="{ 'is-invalid': submitted && f.description.errors }"
             placeholder="Enter Description"
             required
      >
      <div *ngIf="submitted && f.description.errors" class="invalid-feedback">
        <div *ngIf="f.description.errors.required">Description is Required.</div>
      </div>
    </div>
    <div class="form-group">
      <label for="code">Code<span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="code"
             formControlName="code"
             [ngClass]="{ 'is-invalid': submitted && f.code.errors }"
             placeholder="Enter Account Head Code"
             required
      >
      <div *ngIf="submitted && f.code.errors" class="invalid-feedback">
        <div *ngIf="f.code.errors.required">Code is Required.</div>
      </div>
    </div>
    <div class="form-group">
      <label for="accountNumber">Account Number<span class="required">*</span></label>
      <input type="text"
             class="form-control"
             id="accountNumber"
             formControlName="accountNumber"
             placeholder="Ac. Number Starts with 0"
             [ngClass]="{ 'is-invalid': submitted && f.accountNumber.errors }"
             required
      >
      <div *ngIf="submitted && f.accountNumber.errors" class="invalid-feedback">
        <div *ngIf="f.accountNumber.errors.required">Account Number is Required.</div>
      </div>
    </div>
    <div class="form-group">
      <label for="type">Expenditure Type<span class="required">*</span></label>
      <select id="type"
              class="form-control"
              formControlName="type"
              [ngClass]="{ 'is-invalid': submitted && f.type.errors }"
              name="type"
              required>
        <option *ngFor="let event of (expenditureTypes); let i = index"
                [ngValue]="(expenditureTypes)[i].type"
        >{{(expenditureTypes)[i].type + ' ( ' + (expenditureTypes)[i].value + ' )'}}</option>
      </select>
      <div *ngIf="submitted && f.type.errors" class="invalid-feedback">
        <div *ngIf="f.type.errors.required">Expenditure Type is Required.</div>
      </div>
    </div>
    <div class="row" *ngIf="detail">
      <div class="col-md-12 mt-3">
        <strong>Account Holder Detail</strong>
        <hr>
        <div class="col-md-6 form-group float-left">
          <label>Name :</label>
          <p>{{ detail.name }}</p>
        </div>
        <div class="col-md-6 form-group float-left">
          <label>Branch :</label>
          <p>{{ detail.branch }}</p>
        </div>
        <div class="col-md-6 form-group float-left">
          <label>Schema :</label>
          <p>{{ detail.schemeDescription }}</p>
        </div>

        <div class="col-md-6 form-group float-left">
          <label>Is Closed/Is Freeze :</label>
          <p>{{ detail.isClosed }} / {{ detail.isFreeze }}</p>
        </div>
      </div>
    </div>
    <p-footer>
      <div class="row">
        <div class="col-sm-6">
          <button class="btn btn-danger btn-block"
                  (click)="cancel()">
            Cancel
          </button>
        </div>
        <div class="col-sm-6">
          <button class="btn btn-success btn-block"
                  *ngIf="!accountNumberValidated"
                  (click)="submit()"
                  type="submit">
            Submit
          </button>

          <button class="btn btn-success btn-block"
                  [disabled]="loading"
                  *ngIf="accountNumberValidated"
                  (click)="confirm()"
                  type="submit">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Confirm
          </button>
        </div>
      </div>
    </p-footer>
  </form>
</p-dialog>

